package ru.dbotthepony.mc.otm.menu.matter

import com.google.common.collect.ImmutableList
import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.matter.MatterDecomposerBlockEntity
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import net.minecraft.world.SimpleContainer
import net.minecraft.world.inventory.Slot
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.block.entity.RedstoneSetting
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import ru.dbotthepony.mc.otm.core.orNull
import ru.dbotthepony.mc.otm.matter.MatterManager
import ru.dbotthepony.mc.otm.menu.MachineOutputSlot
import ru.dbotthepony.mc.otm.menu.MatteryPoweredMenu
import ru.dbotthepony.mc.otm.menu.MatterySlot
import ru.dbotthepony.mc.otm.menu.input.EnergyPlayerInput
import ru.dbotthepony.mc.otm.menu.input.EnumInputWithFeedback
import ru.dbotthepony.mc.otm.menu.input.ItemHandlerPlayerInput
import ru.dbotthepony.mc.otm.registry.MMenus

class MatterDecomposerMenu @JvmOverloads constructor(
	containerID: Int,
	inventory: Inventory,
	tile: MatterDecomposerBlockEntity? = null
) : MatteryPoweredMenu(MMenus.MATTER_DECOMPOSER, containerID, inventory, tile) {
	val input = object : MatterySlot(tile?.inputContainer ?: SimpleContainer(1), 0) {
		override fun mayPlace(itemStack: ItemStack) = MatterManager.canDecompose(itemStack)
	}

	val outputMain: MachineOutputSlot
	val outputStacking: MachineOutputSlot
	val progressWidget = ProgressGaugeWidget(this, tile)
	val matterWidget = LevelGaugeWidget(this, tile?.getCapability(MatteryCapability.MATTER)?.orNull())
	val itemConfig = ItemHandlerPlayerInput(this, tile?.itemConfig)
	val energyConfig = EnergyPlayerInput(this, tile?.energyConfig)

	init {
		val container = tile?.outputContainer ?: SimpleContainer(2)

		// Выход
		outputMain = MachineOutputSlot(container, 0)
		outputStacking = MachineOutputSlot(container, 1)

		addStorageSlot(outputMain)
		addStorageSlot(outputStacking)
		addStorageSlot(input)

		addInventorySlots()
	}
}
